// (C) 2001 SyGem Software

import java.awt.*;
import java.applet.*;

import com.sygem.jazz3d3.*;
import com.sygem.jazz3d3.primitive.Freeform3d;

public class vertexUV extends Applet implements Runnable {

        Thread m_ce;
        World myWorld;
        int light1;
        int pid;

        int downx = 0;
        int downy = 0;
        double ddx = 0;
        double ddy = 0;
        boolean down = false;

		boolean antialias = false;
		boolean bilinear = false;

        //Construct the applet
        public vertexUV() {
        }

        //Initialize the applet
        public void init() {

                myWorld = new World(this);
                setLayout(new BorderLayout());
                add("Center",myWorld);

                RenderTextured texture_mapper = new RenderTextured();

                String temp = "images/Jazz3D_logo_large.gif";
                Texture tx = TextureLoader.loadImage(temp);

                int t = texture_mapper.setTexture(tx);

                Freeform3d f = new Freeform3d(0,0,8);
                f.setUseVertexUVCoords(true);
                f.addPoint(-1,0.5,0,0,0);
                f.addPoint(0.25,0.5,0,0.625,0);
                f.addPoint(1,0,0,1,0.5);
                f.addPoint(1,-0.5,0,1,1);
                f.addPoint(-0.25,-0.5,0,0.375,1);
                f.addPoint(-1,0,0,0,0.5);
                f.addFace(0,1,3,255,255,255,true);
                f.addFace(1,2,3,255,255,255,true);
                f.addFace(3,4,0,255,255,255,true);
                f.addFace(4,5,0,255,255,255,true);
                f.prep();
                f.setRenderer(texture_mapper);
                pid = myWorld.addObject(f);

                Light l1 = new Light(0,0,1);
                myWorld.addLight(l1);
        }

        //Start the applet
        public void start() {
                if (m_ce == null) {
                        m_ce = new Thread(this);
                        m_ce.start();
                }
        }

        //Stop the applet
        public void stop() {
                if (m_ce != null) {
                        m_ce.stop();
                        m_ce = null;
                }
        }

        //Destroy the applet
        public void destroy() {
        }

        public void run() {

                double z;
                ddx = 0.16;
                ddy = 0.35;
                z = 0.21;
                myWorld.prep();

                while (true) {

                        myWorld.getParentObject(pid).rotateWorld(ddy,ddx,z);
                        myWorld.redraw();
                }
        }

        public boolean mouseDown(Event evt, int x, int y) {
			downx = x;
			downy = y;
			down = true;
			return true;
		}

        public boolean mouseUp(Event evt, int x, int y) {
			down = false;
			return true;
		}

		public boolean mouseDrag(Event evt, int x, int y) {
			if (down) {
				double dx = x - downx;
				double dy = y - downy;
				ddx = (dx / (this.size().width))*10.0;
				ddy = (dy / (this.size().height))*10.0;
			}
			return true;
		}

		public boolean keyDown(Event evt,int key) {

			if ((char)key=='a') {antialias=!antialias; myWorld.setAntiAliasing(antialias); return true; }
			if ((char)key=='b') {bilinear=!bilinear; myWorld.setBilinear(bilinear); return true; }

			return true;
		}

}